package com.logicbig.example;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.module.SimpleModule;
import java.io.IOException;
import java.time.LocalDateTime;

public class ExampleMain {
    public static void main(String[] args) throws IOException {
        System.out.println("-- Java object to JSON --");
        CurrencyRate cr = new CurrencyRate();
        cr.setPair("USD/JPY");
        cr.setRate(109.15);
        cr.setLastUpdated(LocalDateTime.now());
        System.out.println("Java object: " + cr);

        ObjectMapper om = new ObjectMapper();

        //creating a module
        SimpleModule module = new SimpleModule();
        //adding our custom serializer and deserializer
        module.addSerializer(LocalDateTime.class ,new LocalDateTimeSerializer());
        module.addDeserializer(LocalDateTime.class, new LocalDatetimeDeserializer());
        //registering the module with ObjectMapper
        om.registerModule(module);

        String s2 = om.writeValueAsString(cr);
        System.out.println("JSON string: " + s2);

        System.out.println("-- JSON to Java object --");
        CurrencyRate cr2 = om.readValue(s2, CurrencyRate.class);
        System.out.println("Java Object: " + cr2);
    }
}